/*===========================================================================
/
/									ttPage
/							L[e[u^@\e[u
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/


/*===== \ =====*/

/* L[f[^ */
typedef struct {
	LPTSTR	Label;			/* \p */
	WORD	Code;			/* L[R[h */
	WORD	ShiftCode;		/* SHIFTL[̃L[R[h (0=SHIFTƓ) */
} KEY_DATA;


/* @\f[^ */
typedef struct {
	LPTSTR	Label;			/* \p */
	WORD	CommandId;		/* R}hID */
} FUNCTION_DATA;


/*===== L[f[^e[u =====*/

static const KEY_DATA KeyList[] = {
	{	_T("F1"),			VK_F1,			0	},
	{	_T("F2"),			VK_F2,			0	},
	{	_T("F3"),			VK_F3,			0	},
	{	_T("F4"),			VK_F4,			0	},
	{	_T("F5"),			VK_F5,			0	},
	{	_T("F6"),			VK_F6,			0	},
	{	_T("F7"),			VK_F7,			0	},
	{	_T("F8"),			VK_F8,			0	},
	{	_T("F9"),			VK_F9,			0	},
	{	_T("F10"),			VK_F10,			0	},
	{	_T("F11"),			VK_F11,			0	},
	{	_T("F12"),			VK_F12,			0	},
	{	_T("Home"),			VK_HOME,		0	},
	{	_T("End"),			VK_END,			0	},
	{	_T("Back Space"),	VK_BACK,		0	},
	{	_T("Enter"),		VK_RETURN,		0	},
	{	_T("Ins"),			VK_INSERT,		0	},
	{	_T("Del"),			VK_DELETE,		0	},
	{	_T("Up"),			VK_UP,			0	},
	{	_T("Down"),			VK_DOWN,		0	},
	{	_T("Right"),		VK_RIGHT,		0	},
	{	_T("Left"),			VK_LEFT,		0	},
	{	_T("Tab"),			VK_TAB,			0	},
	{	_T("Esc"),			VK_ESCAPE,		0	},
	{	_T("Space"),		VK_SPACE,		0	},
	{	_T("Page Up"),		VK_NEXT,		0	},
	{	_T("Page Down"),	VK_PRIOR,		0	},
	{	_T("1"),			'1',			0	},
	{	_T("2"),			'2',			0	},
	{	_T("3"),			'3',			0	},
	{	_T("4"),			'4',			0	},
	{	_T("5"),			'5',			0	},
	{	_T("6"),			'6',			0	},
	{	_T("7"),			'7',			0	},
	{	_T("8"),			'8',			0	},
	{	_T("9"),			'9',			0	},
	{	_T("0"),			'0',			0	},
	{	_T("A"),			'A',			0	},
	{	_T("B"),			'B',			0	},
	{	_T("C"),			'C',			0	},
	{	_T("D"),			'D',			0	},
	{	_T("E"),			'E',			0	},
	{	_T("F"),			'F',			0	},
	{	_T("G"),			'G',			0	},
	{	_T("H"),			'H',			0	},
	{	_T("I"),			'I',			0	},
	{	_T("J"),			'J',			0	},
	{	_T("K"),			'K',			0	},
	{	_T("L"),			'L',			0	},
	{	_T("M"),			'M',			0	},
	{	_T("N"),			'N',			0	},
	{	_T("O"),			'O',			0	},
	{	_T("P"),			'P',			0	},
	{	_T("Q"),			'Q',			0	},
	{	_T("R"),			'R',			0	},
	{	_T("S"),			'S',			0	},
	{	_T("T"),			'T',			0	},
	{	_T("U"),			'U',			0	},
	{	_T("V"),			'V',			0	},
	{	_T("W"),			'W',			0	},
	{	_T("X"),			'X',			0	},
	{	_T("Y"),			'Y',			0	},
	{	_T("Z"),			'Z',			0	},
	{	_T("-"),			'-',			'='	},
	{	_T("^"),			'^',			'~'	},
	{	_T("\\"),			'\\',			'|'	},
	{	_T("@"),			'@',			'`'	},
	{	_T("["),			'[',			'{'	},
	{	_T("]"),			']',			'}'	},
	{	_T(";"),			';',			'+'	},
	{	_T(":"),			':',			'*'	},
	{	_T("<"),			',',			'<'	},
	{	_T(">"),			'.',			'>'	},
	{	_T("/"),			'/',			'?'	},
	{	_T("_"),			'\\',			'_'	}
};


/*===== @\f[^e[u =====*/

static const FUNCTION_DATA FunctionList[] = {
	{	MSGJPN_55,		0				},
	{	MSGJPN_56,		MENU_OPEN		},
	{	MSGJPN_57,		MENU_SJIS		},
	{	MSGJPN_58,		MENU_JIS		},
	{	MSGJPN_59,		MENU_EUC		},
	{	MSGJPN_60,		MENU_UTF16		},
	{	MSGJPN_61,		MENU_UTF16_BE	},
	{	MSGJPN_62,		MENU_UTF8		},
	{	MSGJPN_63,		MENU_UTF7		},
	{	MSGJPN_64,		MENU_SAVEAS		},
	{	MSGJPN_65,		MENU_PREVLINE	},
	{	MSGJPN_66,		MENU_NEXTLINE	},
	{	MSGJPN_67,		MENU_PREV5LINE	},
	{	MSGJPN_68,		MENU_NEXT5LINE	},
	{	MSGJPN_69,		MENU_PREVPAGE	},
	{	MSGJPN_70,		MENU_NEXTPAGE	},
	{	MSGJPN_71,		MENU_FILETOP	},
	{	MSGJPN_72,		MENU_FILEBTM	},
	{	MSGJPN_73,		MENU_RIGHT		},
	{	MSGJPN_74,		MENU_LEFT		},
	{	MSGJPN_75,		MENU_RIGHT5		},
	{	MSGJPN_76,		MENU_LEFT5		},
	{	MSGJPN_12,		MENU_FIND		},
	{	MSGJPN_14,		MENU_FINDPREV	},
	{	MSGJPN_13,		MENU_FINDNEXT	},
	{	MSGJPN_15,		MENU_FINDDISP	},
	{	MSGJPN_77,		MENU_GOTO		},
	{	MSGJPN_78,		MENU_SELALL		},
	{	MSGJPN_10,		MENU_COPY		},
	{	MSGJPN_79,		MENU_APPENDCOPY	},
	{	MSGJPN_80,		MENU_QUOTECOPY	},
	{	MSGJPN_11,		MENU_PASTE		},
	{	MSGJPN_81,		MENU_REDRAW		},
	{	MSGJPN_16,		MENU_EDITOR		},
	{	MSGJPN_82,		MENU_LINENUM	},
	{	MSGJPN_83,		MENU_HELP		},
	{	MSGJPN_84,		MENU_EXIT		}
};


/*===== vZbgL[f[^ =====*/

/* Windows */
static const ACCEL DefaultAccelTableWin[] = {
	{	FSHIFT|FNOINVERT,				'>',		MENU_FILEBTM	},
	{	FSHIFT|FNOINVERT,				'<',		MENU_FILETOP	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'A',		MENU_SELALL		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'C',		MENU_COPY		},
	{	FVIRTKEY|FNOINVERT,				'E',		MENU_EDITOR		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'F',		MENU_FIND		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'G',		MENU_GOTO		},
	{	FVIRTKEY|FNOINVERT,				'L',		MENU_LINENUM	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'L',		MENU_REDRAW		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'O',		MENU_OPEN		},
	{	FVIRTKEY|FNOINVERT,				'Q',		MENU_EXIT		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'S',		MENU_FIND		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'U',		MENU_FINDDISP	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'V',		MENU_PASTE		},
	{	FVIRTKEY|FALT|FNOINVERT,		'V',		MENU_OPEN		},
	{	FVIRTKEY|FNOINVERT,				VK_END,		MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				VK_HOME,	MENU_FILETOP	},
	{	FVIRTKEY|FNOINVERT,				VK_F3,		MENU_FINDNEXT	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_F3,		MENU_FINDPREV	},
	{	FVIRTKEY|FNOINVERT,				VK_F1,		MENU_HELP		},
	{	FVIRTKEY|FNOINVERT,				VK_LEFT,	MENU_LEFT		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_LEFT,	MENU_LEFT5		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_DOWN,	MENU_NEXT5LINE	},
	{	FVIRTKEY|FNOINVERT,				VK_DOWN,	MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				VK_RETURN,	MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				VK_NEXT,	MENU_NEXTPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_SPACE,	MENU_NEXTPAGE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_UP,		MENU_PREV5LINE	},
	{	FVIRTKEY|FNOINVERT,				VK_UP,		MENU_PREVLINE	},
	{	FVIRTKEY|FNOINVERT,				VK_PRIOR,	MENU_PREVPAGE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_SPACE,	MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_RIGHT,	MENU_RIGHT		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_RIGHT,	MENU_RIGHT5		}
};


/* less */
static const ACCEL DefaultAccelTableLess[] = {
	{	FNOINVERT,						'/',		MENU_FIND		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		'5',		MENU_FILETOP	},
	{	FNOINVERT|FSHIFT,				'<',		MENU_FILETOP	},
	{	FNOINVERT|FSHIFT,				'>',		MENU_FILEBTM	},
	{	FNOINVERT|FSHIFT,				'?',		MENU_FINDBACKWD	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'A',		MENU_SELALL		},
	{	FVIRTKEY|FNOINVERT,				'B',		MENU_PREVPAGE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'B',		MENU_PREVPAGE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'C',		MENU_COPY		},
	{	FVIRTKEY|FNOINVERT,				'D',		MENU_NEXT5LINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'D',		MENU_NEXT5LINE	},
	{	FVIRTKEY|FNOINVERT,				'E',		MENU_NEXTLINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'E',		MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				'F',		MENU_NEXTPAGE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'F',		MENU_NEXTPAGE	},
	{	FVIRTKEY|FNOINVERT,				'G',		MENU_FILETOP	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'G',		MENU_GOTO		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		'G',		MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				'J',		MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				'K',		MENU_PREVLINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'K',		MENU_PREVLINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'L',		MENU_REDRAW		},
	{	FVIRTKEY|FNOINVERT,				'N',		MENU_FINDNEXT	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'N',		MENU_NEXTLINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		'N',		MENU_FINDPREV	},
	{	FVIRTKEY|FNOINVERT,				'P',		MENU_FILETOP	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'P',		MENU_PREVLINE	},
	{	FVIRTKEY|FNOINVERT,				'Q',		MENU_EXIT		},
	{	FVIRTKEY|FNOINVERT,				'R',		MENU_REDRAW		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'S',		MENU_FIND		},
	{	FVIRTKEY|FNOINVERT,				'U',		MENU_PREV5LINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'U',		MENU_PREV5LINE	},
	{	FVIRTKEY|FALT|FNOINVERT,		'U',		MENU_FINDDISP	},
	{	FVIRTKEY|FNOINVERT,				'V',		MENU_EDITOR		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'V',		MENU_NEXTPAGE	},
	{	FVIRTKEY|FALT|FNOINVERT,		'V',		MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				'W',		MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				'Y',		MENU_PREVLINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'Y',		MENU_PREVLINE	},
	{	FVIRTKEY|FNOINVERT,				'Z',		MENU_NEXTPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_DOWN,	MENU_NEXTLINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_DOWN,	MENU_NEXT5LINE	},
	{	FVIRTKEY|FNOINVERT,				VK_END,		MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				VK_F1,		MENU_HELP		},
	{	FVIRTKEY|FNOINVERT,				VK_F3,		MENU_FINDNEXT	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_F3,		MENU_FINDPREV	},
	{	FVIRTKEY|FNOINVERT,				VK_HOME,	MENU_FILETOP	},
	{	FVIRTKEY|FNOINVERT,				VK_LEFT,	MENU_LEFT		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_LEFT,	MENU_LEFT5		},
	{	FVIRTKEY|FNOINVERT,				VK_NEXT,	MENU_NEXTPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_PRIOR,	MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_RETURN,	MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				VK_RIGHT,	MENU_RIGHT		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_RIGHT,	MENU_RIGHT5		},
	{	FVIRTKEY|FNOINVERT,				VK_SPACE,	MENU_NEXTPAGE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_SPACE,	MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_UP,		MENU_PREVLINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_UP,		MENU_PREV5LINE	}
};


/* DOS */
static const ACCEL DefaultAccelTableDos[] = {
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'A',		MENU_SELALL		},
	{	FVIRTKEY|FNOINVERT,				'B',		MENU_FIND		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'B',		MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				'C',		MENU_NEXTPAGE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'C',		MENU_COPY		},
	{	FVIRTKEY|FNOINVERT,				'D',		MENU_NEXT5LINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'D',		MENU_NEXT5LINE	},
	{	FVIRTKEY|FNOINVERT,				'E',		MENU_PREVLINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'E',		MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				'F',		MENU_FIND		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'I',		MENU_NEXTPAGE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'I',		MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				'J',		MENU_NEXTLINE	},
	{	FVIRTKEY|FNOINVERT,				'K',		MENU_PREVLINE	},
	{	FVIRTKEY|FNOINVERT,				'L',		MENU_FINDNEXT	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'N',		MENU_GOTO		},
	{	FVIRTKEY|FNOINVERT,				'O',		MENU_FINDPREV	},
	{	FVIRTKEY|FNOINVERT,				'Q',		MENU_EXIT		},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'Q',		MENU_EXIT		},
	{	FVIRTKEY|FNOINVERT,				'R',		MENU_PREVPAGE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'R',		MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				'S',		MENU_PREV5LINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'S',		MENU_PREV5LINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'T',		MENU_FILETOP	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'U',		MENU_FINDDISP	},
	{	FVIRTKEY|FNOINVERT,				'W',		MENU_FILETOP	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'W',		MENU_SELALL		},
	{	FVIRTKEY|FNOINVERT,				'X',		MENU_NEXTLINE	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'X',		MENU_PREVLINE	},
	{	FVIRTKEY|FNOINVERT,				'Z',		MENU_FILEBTM	},
	{	FVIRTKEY|FCONTROL|FNOINVERT,	'Z',		MENU_SELALL		},
	{	FVIRTKEY|FNOINVERT,				VK_DOWN,	MENU_NEXTLINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_DOWN,	MENU_NEXT5LINE	},
	{	FVIRTKEY|FNOINVERT,				VK_END,		MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				VK_ESCAPE,	MENU_EXIT		},
	{	FVIRTKEY|FNOINVERT,				VK_F3,		MENU_FINDNEXT	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_F3,		MENU_FINDPREV	},
	{	FVIRTKEY|FNOINVERT,				VK_HOME,	MENU_FILETOP	},
	{	FVIRTKEY|FNOINVERT,				VK_LEFT,	MENU_PREV5LINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_LEFT,	MENU_FILETOP	},
	{	FVIRTKEY|FNOINVERT,				VK_NEXT,	MENU_NEXTPAGE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_NEXT,	MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				VK_PRIOR,	MENU_PREVPAGE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_PRIOR,	MENU_FILETOP	},
	{	FVIRTKEY|FNOINVERT,				VK_RETURN,	MENU_EXIT		},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_RETURN,	MENU_EDITOR		},
	{	FVIRTKEY|FNOINVERT,				VK_RIGHT,	MENU_NEXT5LINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_RIGHT,	MENU_FILEBTM	},
	{	FVIRTKEY|FNOINVERT,				VK_SPACE,	MENU_NEXTPAGE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_SPACE,	MENU_PREVPAGE	},
	{	FVIRTKEY|FNOINVERT,				VK_UP,		MENU_PREVLINE	},
	{	FVIRTKEY|FSHIFT|FNOINVERT,		VK_UP,		MENU_PREV5LINE	}
};


