/*===========================================================================
/
/									ttPage
/								IvVݒ
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>
#include <htmlhelp.h>

#include "common.h"
#include "resource.h"
#include "keytable.h"


#define ACCELERATOR_TABLE_STEP	10


/*===== vg^Cv =====*/

static int GetIndexFromKeyTable(WORD key, int shift, int ctrl, int alt, int virtual);
static BYTE GetVirtValue(int shift, int ctrl, int alt, int virtual);
static WORD GetCommandIdFromKeyTable(int index);
static void SetCommandIdToKeyTable(WORD key, int shift, int ctrl, int alt, int virtual, WORD command);
static WORD GetKeyCodeFromKetList(int index, int shift, int *virtual);
static int GetIndexFromFunctionList(WORD command);
static WORD GetCommandIdFromFunctionList(int index);
static LRESULT CALLBACK KeySettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static LRESULT CALLBACK MiscSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static int GetDecimalText(HWND hDlg, int ctrl);
static void SetDecimalText(HWND hDlg, int ctrl, int num);

/*===== [Jȃ[N ======*/

static int Apply;

/*===== OQ =====*/

GLOBALSET	GlobalSet;			/* ݒl */

extern HACCEL AcceletorHandle;
extern HWND hWndHelp;


/*-------------------------------------------------------------------------------
Name    :	SetOption
Desc    :	IvVݒ
Param   :	hWnd	eEChẼEChEnh
Return  :	Xe[^X (YES/NO=)
Note    :	
-------------------------------------------------------------------------------*/
int SetOption(HWND hWnd)
{
	PROPSHEETPAGE		psp[2];
	PROPSHEETHEADER		psh;

	psp[0].dwSize = sizeof(PROPSHEETPAGE);
	psp[0].dwFlags = PSP_USETITLE | PSP_HASHELP;
	psp[0].hInstance = GetProgInst();
	psp[0].pszTemplate = MAKEINTRESOURCE(opt_key_dlg);
	psp[0].pszIcon = NULL;
	psp[0].pfnDlgProc = KeySettingProc;
	psp[0].pszTitle = MSGJPN_21;
	psp[0].lParam = 0;
	psp[0].pfnCallback = NULL;

	psp[1].dwSize = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags = PSP_USETITLE | PSP_HASHELP;
	psp[1].hInstance = GetProgInst();
	psp[1].pszTemplate = MAKEINTRESOURCE(opt_misc_dlg);
	psp[1].pszIcon = NULL;
	psp[1].pfnDlgProc = MiscSettingProc;
	psp[1].pszTitle = MSGJPN_22;
	psp[1].lParam = 0;
	psp[1].pfnCallback = NULL;

	psh.dwSize = sizeof(PROPSHEETHEADER);
	psh.dwFlags = PSH_HASHELP | PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE;
	psh.hwndParent = hWnd;
	psh.hInstance = GetProgInst();
	psh.pszIcon = NULL;
	psh.pszCaption = MSGJPN_23;
	psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.nStartPage = 0;
	psh.ppsp = (LPCPROPSHEETPAGE)&psp;
	psh.pfnCallback = NULL;

	Apply = NO;
	PropertySheet(&psh);

	return(Apply);
}


/*-------------------------------------------------------------------------------
Name    :	CopyPresetAppKeyTable
Desc    :	vZbgꂽL[e[uRs[
Param   :	type	L[̃^Cv (UI_xxxx)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void CopyPresetAppKeyTable(int type)
{
	free(GlobalSet.AcceleratorTable);
	GlobalSet.AcceleratorDataNum = 0;
	GlobalSet.AcceleratorDataMax = 0;

	switch(type)
	{
		case UI_LESS :
			GlobalSet.AcceleratorDataNum = sizeof(DefaultAccelTableLess) / sizeof(ACCEL);
			GlobalSet.AcceleratorDataMax = GlobalSet.AcceleratorDataNum;
			GlobalSet.AcceleratorTable = Malloc(sizeof(DefaultAccelTableLess));
			memcpy(GlobalSet.AcceleratorTable, DefaultAccelTableLess, sizeof(DefaultAccelTableLess));
			break;

		case UI_DOS :
			GlobalSet.AcceleratorDataNum = sizeof(DefaultAccelTableDos) / sizeof(ACCEL);
			GlobalSet.AcceleratorDataMax = GlobalSet.AcceleratorDataNum;
			GlobalSet.AcceleratorTable = Malloc(sizeof(DefaultAccelTableDos));
			memcpy(GlobalSet.AcceleratorTable, DefaultAccelTableDos, sizeof(DefaultAccelTableDos));
			break;

		case UI_WINDOWS :
		default :
			GlobalSet.AcceleratorDataNum = sizeof(DefaultAccelTableWin) / sizeof(ACCEL);
			GlobalSet.AcceleratorDataMax = GlobalSet.AcceleratorDataNum;
			GlobalSet.AcceleratorTable = Malloc(sizeof(DefaultAccelTableWin));
			memcpy(GlobalSet.AcceleratorTable, DefaultAccelTableWin, sizeof(DefaultAccelTableWin));
			break;
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	RegistAppKeyTable
Desc    :	L[e[uVXeɓo^
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void RegistAppKeyTable(void)
{
	if(AcceletorHandle != NULL)
	{
		DestroyAcceleratorTable(AcceletorHandle);
		AcceletorHandle = NULL;
	}
	AcceletorHandle = CreateAcceleratorTable(GlobalSet.AcceleratorTable, GlobalSet.AcceleratorDataNum);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	UnregistAppKeyTable
Desc    :	L[e[ũVXe̓o^
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void UnregistAppKeyTable(void)
{
	DestroyAcceleratorTable(AcceletorHandle);

	free(GlobalSet.AcceleratorTable);
	GlobalSet.AcceleratorDataNum = 0;
	GlobalSet.AcceleratorDataMax = 0;
}


/*-------------------------------------------------------------------------------
Name    :	GetIndexFromKeyTable
Desc    :	L[e[uł̎wL[̃CfbNX擾
Param   :	key		L[R[h
			shift	Vtg̏ (0/1)
			ctrl	CTRL̏ (0/1)
			alt		ALT̏ (0/1)
			virtual	virtualL[tO (0/1)
Return  :	CfbNXl
Note    :	
-------------------------------------------------------------------------------*/
static int GetIndexFromKeyTable(WORD key, int shift, int ctrl, int alt, int virtual)
{
	int		i;
	BYTE	flg;
	int		ret;

	ret = -1;
	flg = GetVirtValue(shift, ctrl, alt, virtual);
	for(i = 0; i < GlobalSet.AcceleratorDataNum; i++)
	{
		if((GlobalSet.AcceleratorTable[i].fVirt == flg) && (GlobalSet.AcceleratorTable[i].key == key))
		{
			ret = i;
			break;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetVirtValue
Desc    :	Virtl擾
Param   :	shift	Vtg̏ (0/1)
			ctrl	CTRL̏ (0/1)
			alt		ALT̏ (0/1)
			virtual	virtualL[tO (0/1)
Return  :	Virtl
Note    :	
-------------------------------------------------------------------------------*/
static BYTE GetVirtValue(int shift, int ctrl, int alt, int virtual)
{
	BYTE	flg;

	flg = FNOINVERT;
	if(virtual)
	{
		flg |= FVIRTKEY;
	}
	if(shift)
	{
		flg |= FSHIFT;
	}
	if(ctrl)
	{
		flg |= FCONTROL;
	}
	if(alt)
	{
		flg |= FALT;
	}
	return(flg);
}


/*-------------------------------------------------------------------------------
Name    :	GetCommandIdFromKeyTable
Desc    :	L[e[ũCfbNXlR}hID擾
Param   :	index	CfbNX
Return  :	R}hID
Note    :	
-------------------------------------------------------------------------------*/
static WORD GetCommandIdFromKeyTable(int index)
{
	if(index == -1)
	{
		return(0);
	}
	return(GlobalSet.AcceleratorTable[index].cmd);
}


/*-------------------------------------------------------------------------------
Name    :	SetCommandIdToKeyTable
Desc    :	L[e[uɓo^
Param   :	key		L[R[h
			shift	Vtg̏ (0/1)
			ctrl	CTRL̏ (0/1)
			alt		ALT̏ (0/1)
			virtual	virtualL[tO (0/1)
			command	R}hID
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void SetCommandIdToKeyTable(WORD key, int shift, int ctrl, int alt, int virtual, WORD command)
{
	int		index;

	index = GetIndexFromKeyTable(key, shift, ctrl, alt, virtual);
	if((index == -1) && (command != 0))
	{
		/* ܂o^ĂȂL[ */
		if(GlobalSet.AcceleratorDataNum >= GlobalSet.AcceleratorDataMax)
		{
			/* e[ug */
			GlobalSet.AcceleratorDataMax += ACCELERATOR_TABLE_STEP;
			GlobalSet.AcceleratorTable = Realloc(GlobalSet.AcceleratorTable, GlobalSet.AcceleratorDataMax * sizeof(ACCEL));
		}
		index = GlobalSet.AcceleratorDataNum;
		GlobalSet.AcceleratorDataNum++;
		GlobalSet.AcceleratorTable[index].fVirt = GetVirtValue(shift, ctrl, alt, virtual);
		GlobalSet.AcceleratorTable[index].key = key;
		GlobalSet.AcceleratorTable[index].cmd = command;
	}
	else
	{
		if(command != 0)
		{
			/* łɓo^ς݂̃L[̃R}hύX */
			GlobalSet.AcceleratorTable[index].cmd = command;
		}
		else
		{
			/* R}h"(Ȃ)"̎͋l߂ */
			memmove((char*)&GlobalSet.AcceleratorTable[index], (char*)&GlobalSet.AcceleratorTable[index+1], (GlobalSet.AcceleratorDataNum - index - 1) * sizeof(ACCEL));
			GlobalSet.AcceleratorDataNum--;
		}
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetKeyCodeFromKetList
Desc    :	L[XgL[R[h擾
Param   :	index		CfbNX
			shift		Vtg̏ (0/1)
			virtual		[out] virtualL[tO (0/1)
Return  :	L[R[h
Note    :	
-------------------------------------------------------------------------------*/
static WORD GetKeyCodeFromKetList(int index, int shift, int *virtual)
{
	if(index == -1)
	{
		return(0);
	}

	if(KeyList[index].ShiftCode == 0)
	{
		*virtual = 1;
		return(KeyList[index].Code);
	}
	else
	{
		*virtual = 0;
		if(shift)
		{
			return(KeyList[index].ShiftCode);
		}
		else
		{
			return(KeyList[index].Code);
		}
	}
}


/*-------------------------------------------------------------------------------
Name    :	GetIndexFromFunctionList
Desc    :	@\Xgł̃R}h̃CfbNX擾
Param   :	command		R}hID
Return  :	CfbNXl
Note    :	
-------------------------------------------------------------------------------*/
static int GetIndexFromFunctionList(WORD command)
{
	int		i;
	int		ret;

	ret = 0;
	for(i = 0; i < sizeof(FunctionList)/sizeof(FUNCTION_DATA); i++)
	{
		if(FunctionList[i].CommandId == command)
		{
			ret = i;
			break;
		}
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	GetCommandIdFromFunctionList
Desc    :	@\Xgł̎wCfbNX̃R}hID擾
Param   :	index		CfbNX
Return  :	R}hID
Note    :	
-------------------------------------------------------------------------------*/
static WORD GetCommandIdFromFunctionList(int index)
{
	return(FunctionList[index].CommandId);
}


/*-------------------------------------------------------------------------------
Name    :	KeySettingProc
Desc    :	ݒEChẼbZ[W
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK KeySettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR			*pnmhdr;
	int				i;
	WORD			key;
	int				shift;
	int				ctrl;
	int				alt;
	int				virtual;
	WORD			cmd;
	int				index;
	static ACCEL	*oldAcceleratorTable;
	static int		oldAcceleratorDataNum;
	static int		oldAcceleratorDataMax;

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_24);
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_25);
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)MSGJPN_26);
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_SETCURSEL, 0, 0);

			for(i = 0; i < sizeof(KeyList)/sizeof(KEY_DATA); i++)
			{
				SendDlgItemMessage(hDlg, KEY_KEY_LIST, LB_ADDSTRING, 0, (LPARAM)KeyList[i].Label);
			}
			for(i = 0; i < sizeof(FunctionList)/sizeof(FUNCTION_DATA); i++)
			{
				SendDlgItemMessage(hDlg, KEY_FUNCTION_LIST, LB_ADDSTRING, 0, (LPARAM)FunctionList[i].Label);
			}

			/* LẐ߂Ɍ݂̐ݒRs[ĎcĂ */

			oldAcceleratorDataNum = GlobalSet.AcceleratorDataNum;
			oldAcceleratorDataMax = GlobalSet.AcceleratorDataMax;
			oldAcceleratorTable = Malloc(GlobalSet.AcceleratorDataMax * sizeof(ACCEL));
			memcpy(oldAcceleratorTable, GlobalSet.AcceleratorTable, GlobalSet.AcceleratorDataMax * sizeof(ACCEL));
			return(TRUE);

		case WM_NOTIFY :
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					/* Âݒ͔j */
					free(oldAcceleratorTable);
					Apply = YES;
					break;

				case PSN_QUERYCANCEL :
					free(GlobalSet.AcceleratorTable);
					GlobalSet.AcceleratorTable = oldAcceleratorTable;
					GlobalSet.AcceleratorDataNum = oldAcceleratorDataNum;
					GlobalSet.AcceleratorDataMax = oldAcceleratorDataMax;
					break;

				case PSN_RESET :
					break;

				case PSN_HELP :
					hWndHelp = HtmlHelp(NULL, AskHelpFilePath(), HH_HELP_CONTEXT, IDH_HELP_TOPIC_0000012);
					break;
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case KEY_KEY_LIST :
					if(HIWORD(wParam) != LBN_SELCHANGE)
					{
						break;
					}
					/* break͂Ȃ */
				case KEY_WITH_SHIFT :
				case KEY_WITH_CTRL :
				case KEY_WITH_ALT :
					/* w肳ꂽL[Ɋ蓖ĂĂ@\I\ */
					index = (int)SendDlgItemMessage(hDlg, KEY_KEY_LIST, LB_GETCURSEL, 0, 0);
					shift = SendDlgItemMessage(hDlg, KEY_WITH_SHIFT, BM_GETCHECK, 0, 0);
					ctrl = SendDlgItemMessage(hDlg, KEY_WITH_CTRL, BM_GETCHECK, 0, 0);
					alt = SendDlgItemMessage(hDlg, KEY_WITH_ALT, BM_GETCHECK, 0, 0);
					key = GetKeyCodeFromKetList(index, shift, &virtual);
					index = GetIndexFromKeyTable(key, shift, ctrl, alt, virtual);
					cmd = GetCommandIdFromKeyTable(index);
					index = GetIndexFromFunctionList(cmd);
					SendDlgItemMessage(hDlg, KEY_FUNCTION_LIST, LB_SETCURSEL, index, 0);
					break;

				case KEY_FUNCTION_LIST :
					if(HIWORD(wParam) == LBN_SELCHANGE)
					{
						/* w肳ꂽL[̋@\ύX */
						index = (int)SendDlgItemMessage(hDlg, KEY_FUNCTION_LIST, LB_GETCURSEL, 0, 0);
						cmd = GetCommandIdFromFunctionList(index);
						index = (int)SendDlgItemMessage(hDlg, KEY_KEY_LIST, LB_GETCURSEL, 0, 0);
						if(index != LB_ERR)
						{
							shift = SendDlgItemMessage(hDlg, KEY_WITH_SHIFT, BM_GETCHECK, 0, 0);
							ctrl = SendDlgItemMessage(hDlg, KEY_WITH_CTRL, BM_GETCHECK, 0, 0);
							alt = SendDlgItemMessage(hDlg, KEY_WITH_ALT, BM_GETCHECK, 0, 0);
							key = GetKeyCodeFromKetList(index, shift, &virtual);
							SetCommandIdToKeyTable(key, shift, ctrl, alt, virtual, cmd);
						}
					}
					break;

				case KEY_LOAD :
					if(MessageBox(hDlg, MSGJPN_27, _T("ttPage"), MB_YESNO) == IDYES)
					{
						index = (int)SendDlgItemMessage(hDlg, KEY_TYPE, CB_GETCURSEL, 0, 0);
						CopyPresetAppKeyTable(index);
					}
					break;
			}
			break;
	}
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	MiscSettingProc
Desc    :	̑ݒEChẼbZ[W
Param   :	hDlg		EChEnh
			message		bZ[Wԍ
			wParam		bZ[W WPARAM 
			lParam		bZ[W LPARAM 
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK MiscSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR	*pnmhdr;

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, MISC_SAVESIZE, BM_SETCHECK, GlobalSet.SaveWinSize, 0);
			SendDlgItemMessage(hDlg, MISC_SAVEPOS, BM_SETCHECK, GlobalSet.SaveWinPos, 0);
			SendDlgItemMessage(hDlg, MISC_INISAVE, BM_SETCHECK, GlobalSet.RegType, 0);
			SendDlgItemMessage(hDlg, MISC_TOOLBAR, BM_SETCHECK, GlobalSet.ToolBar, 0);
			SendDlgItemMessage(hDlg, MISC_STSBAR, BM_SETCHECK, GlobalSet.StatusBar, 0);
			SendDlgItemMessage(hDlg, MISC_QUOTE, EM_LIMITTEXT, QUOTE_MAXLEN, 0);
			SendDlgItemMessage(hDlg, MISC_QUOTE, WM_SETTEXT, 0, (LPARAM)GlobalSet.QuoteStr);

			SendDlgItemMessage(hDlg, KEY_ERR_BELL, BM_SETCHECK, GlobalSet.ErrBell, 0);
			SendDlgItemMessage(hDlg, KEY_HIST, EM_LIMITTEXT, (WPARAM)2, 0);
			SetDecimalText(hDlg, KEY_HIST, GlobalSet.FileHist);
			SendDlgItemMessage(hDlg, KEY_HIST_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(HISTORY_MAX, 0));
			SendDlgItemMessage(hDlg, KEY_MOUSECARET, BM_SETCHECK, GlobalSet.DispCaret, 0);
			SendDlgItemMessage(hDlg, KEY_SMOOTH, BM_SETCHECK, GlobalSet.SmoothLine, 0);
			SendDlgItemMessage(hDlg, KEY_PAGESMOOTH, BM_SETCHECK, GlobalSet.SmoothPage, 0);
			SendDlgItemMessage(hDlg, KEY_SMOOTHRATE, TBM_SETRANGE, TRUE, MAKELPARAM(1, 30));
			SendDlgItemMessage(hDlg, KEY_SMOOTHRATE, TBM_SETPOS, TRUE, GlobalSet.SmoothRate);
			return(TRUE);

		case WM_NOTIFY:
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					GlobalSet.SaveWinSize = SendDlgItemMessage(hDlg, MISC_SAVESIZE, BM_GETCHECK, 0, 0);
					GlobalSet.SaveWinPos = SendDlgItemMessage(hDlg, MISC_SAVEPOS, BM_GETCHECK, 0, 0);
					GlobalSet.RegType = SendDlgItemMessage(hDlg, MISC_INISAVE, BM_GETCHECK, 0, 0);
					GlobalSet.ToolBar = SendDlgItemMessage(hDlg, MISC_TOOLBAR, BM_GETCHECK, 0, 0);
					GlobalSet.StatusBar = SendDlgItemMessage(hDlg, MISC_STSBAR, BM_GETCHECK, 0, 0);
					SendDlgItemMessage(hDlg, MISC_QUOTE, WM_GETTEXT, QUOTE_MAXLEN+1, (LPARAM)GlobalSet.QuoteStr);

					GlobalSet.ErrBell = SendDlgItemMessage(hDlg, KEY_ERR_BELL, BM_GETCHECK, 0, 0);
					GlobalSet.FileHist = GetDecimalText(hDlg, KEY_HIST);
					CheckRange2(&GlobalSet.FileHist, HISTORY_MAX, 0);
					GlobalSet.DispCaret = SendDlgItemMessage(hDlg, KEY_MOUSECARET, BM_GETCHECK, 0, 0);
					GlobalSet.SmoothLine = SendDlgItemMessage(hDlg, KEY_SMOOTH, BM_GETCHECK, 0, 0);
					GlobalSet.SmoothPage = SendDlgItemMessage(hDlg, KEY_PAGESMOOTH, BM_GETCHECK, 0, 0);
					GlobalSet.SmoothRate = SendDlgItemMessage(hDlg, KEY_SMOOTHRATE, TBM_GETPOS, 0, 0);
					Apply = YES;
					break;

				case PSN_RESET :
					break;

				case PSN_HELP :
					hWndHelp = HtmlHelp(NULL, AskHelpFilePath(), HH_HELP_CONTEXT, IDH_HELP_TOPIC_0000014);
					break;
			}
			break;
	}
    return(FALSE);
}


/*-------------------------------------------------------------------------------
Name    :	GetDecimalText
Desc    :	_CAÕRg[POi擾
Param   :	hDlg	EChEnh
			ctrl	Rg[ID
Return  :	l
Note    :	
-------------------------------------------------------------------------------*/
static int GetDecimalText(HWND hDlg, int ctrl)
{
	_TCHAR	tmp[40];

	SendDlgItemMessage(hDlg, ctrl, WM_GETTEXT, (WPARAM)39, (LPARAM)tmp);
	return(_ttoi(tmp));
}


/*-------------------------------------------------------------------------------
Name    :	SetDecimalText
Desc    :	_CAÕRg[ɂPOiZbg
Param   :	hDlg	EChEnh
			ctrl	Rg[ID
			num		l
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void SetDecimalText(HWND hDlg, int ctrl, int num)
{
	_TCHAR	tmp[40];

	_stprintf(tmp, _T("%d"), num);
	SendDlgItemMessage(hDlg, ctrl, WM_SETTEXT, 0, (LPARAM)tmp);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	CheckRange2
Desc    :	ݒl͈̔̓`FbN
Param   :	cur		[in/out] ݒl
			max		ől
			min		ŏl
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void CheckRange2(int *cur, int max, int min)
{
	if(*cur < min)
	{
		*cur = min;
	}
	if(*cur > max)
	{
		*cur = max;
	}
	return;
}


